/* Automatically generated from Maple, do not modify! */
#include <float.h>
#include <stdio.h>
#define undefined_ 0.0
#define infinity_ DBL_MAX
double dot2 (double *v, double *w)
{
  return(v[0] * w[0] + v[1] * w[1]);
}
void computeAbd_C (
  double p1[2],
  double p2[2],
  double p3[2],
  double q1[2],
  double q2[2],
  double R[2][2],
  double coef[4])
{
  double v2[2];
  double v3[2];
  double V[2][2];
  double P[2][2];
  double w1[2];
  double w2[2];
  double s2[2];
  double bt[2];
  double b[2];
  double A;
  double C;
  double d0;
  double Rw2[2];
  double Rw1[2];
  double invdet;
  v2[0] = p2[0] - p1[0];
  v2[1] = p2[1] - p1[1];
  v3[0] = p3[0] - p1[0];
  v3[1] = p3[1] - p1[1];
  s2[0] = q2[0] - q1[0];
  s2[1] = q2[1] - q1[1];
  V[0][0] = v2[0];
  V[0][1] = v3[0];
  V[1][0] = v2[1];
  V[1][1] = v3[1];
  invdet = 0.1e1 / (V[0][0] * V[1][1] - V[0][1] * V[1][0]);
  P[0][0] = V[1][1] * invdet;
  P[0][1] = -V[0][1] * invdet;
  P[1][0] = -V[1][0] * invdet;
  P[1][1] = V[0][0] * invdet;
  w1[0] = P[0][0];
  w1[1] = P[0][1];
  w2[0] = P[1][0];
  w2[1] = P[1][1];
  A = dot2(w2, w2);
  Rw1[0] = w1[0] * R[0][0] + w1[1] * R[0][1];
  Rw1[1] = w1[0] * R[1][0] + w1[1] * R[1][1];
  Rw2[0] = w2[0] * R[0][0] + w2[1] * R[0][1];
  Rw2[1] = w2[0] * R[1][0] + w2[1] * R[1][1];
  bt[0] = -(dot2(w1, w2) * s2[0] - Rw2[0]) / A;
  bt[1] = -(dot2(w1, w2) * s2[1] - Rw2[1]) / A;
  C = (double) (dot2(s2, s2) * dot2(w1, w1) - 2 * dot2(s2, Rw1) + 2) / A;
  d0 = dot2(bt, bt) - C;
  b[0] = q1[0] + bt[0];
  b[1] = q1[1] + bt[1];
  coef[0] = A;
  coef[1] = b[0];
  coef[2] = b[1];
  coef[3] = d0;
  ;
}
double updateOpt_C (
  int N,
  double A[],
  double b[][2],
  double d0[],
  double xtry[2],
  double ksq_min,
  double xstar[2],
  double xstar_new[2])
{
  int m;
  double ksq_min_new;
  double Dsm;
  double maxD;
  double dm[2];
  maxD = -infinity_;
  dm[0] = 0.0e0;
  dm[1] = 0.0e0;
  for (m = 1; m <= N; m++)
  {
    dm[0] = xtry[0] - b[m - 1][0];
    dm[1] = xtry[1] - b[m - 1][1];
    Dsm = A[m - 1] * (dot2(dm, dm) - d0[m - 1]);
    maxD = (Dsm >= maxD ? Dsm : maxD);
  }
  if (maxD < ksq_min)
  {
    ksq_min_new = maxD;
    xstar_new[0] = xtry[0];
    xstar_new[1] = xtry[1];
  }
  else
  {
    ksq_min_new = ksq_min;
    xstar_new[0] = xstar[0];
    xstar_new[1] = xstar[1];
  }
  return(ksq_min_new);
}
#include <math.h>

int solveQQ_C (
  double A1,
  double B1[2],
  double C1,
  double A2,
  double B2[2],
  double C2,
  double q1[2],
  double q2[2])
{
  double A;
  double Bu;
  double Bv;
  double B;
  double C;
  double Fu;
  double Fv;
  double G;
  double Hu;
  double Hv;
  double Fpu;
  double Fpv;
  double lensq;
  double Discr;
  double a;
  double b;
  double c;
  double t1;
  double t2;
  int success;
  q1[0] = undefined_;
  q1[1] = undefined_;
  q2[0] = undefined_;
  q2[1] = undefined_;
  if (DBL_EPSILON < fabs(A1) || DBL_EPSILON < fabs(A2))
  {
    if (DBL_EPSILON < fabs(A1) && DBL_EPSILON < fabs(A2))
    {
      Fu = B1[0] / A1 - B2[0] / A2;
      Fv = B1[1] / A1 - B2[1] / A2;
      G = C1 / A1 - C2 / A2;
      A = A1;
      Bu = B1[0];
      Bv = B1[1];
      C = C1;
    }
    else if (DBL_EPSILON < fabs(A1))
    {
      Fu = B2[0];
      Fv = B2[1];
      G = C2;
      A = A1;
      Bu = B1[0];
      Bv = B1[1];
      C = C1;
    }
    else
    {
      Fu = B1[0];
      Fv = B1[1];
      G = C1;
      A = A2;
      Bu = B2[0];
      Bv = B2[1];
      C = C2;
    }
    Fpu = -Fv;
    Fpv = Fu;
    lensq = Fu * Fu + Fv * Fv;
    success = DBL_EPSILON < lensq;
    if (success)
    {
      Hu = -G / lensq * Fu;
      Hv = -G / lensq * Fv;
      a = lensq * A;
      b = (0.2e1 * A * Hu + Bu) * Fpu + (0.2e1 * A * Hv + Bv) * Fpv;
      c = A * (Hu * Hu + Hv * Hv) + Bu * Hu + Bv * Hv + C;
      Discr = b * b - 0.4e1 * a * c;
      success = 0.0e0 <= Discr;
      if (success)
      {
        t1 = (-b + sqrt(Discr)) / a / 0.2e1;
        t2 = (-b - sqrt(Discr)) / a / 0.2e1;
        q1[0] = Fpu * t1 + Hu;
        q1[1] = Fpv * t1 + Hv;
        q2[0] = Fpu * t2 + Hu;
        q2[1] = Fpv * t2 + Hv;
      }
    }
  }
  else
  {
    success = (int) (DBL_EPSILON < dot2(B1, B1) && DBL_EPSILON < dot2(B2, B2));
    if (success)
    {
      Fpu = -B1[1];
      Fpv = B1[0];
      lensq = dot2(B1, B1);
      Hu = -C1 * B1[0] / lensq;
      Hv = -C1 * B1[1] / lensq;
      B = B2[0] * Fpu + B2[1] * Fpv;
      C = Hu * B2[0] + Hv * B2[1] + C2;
      success = DBL_EPSILON < fabs(B);
      if (success)
      {
        q1[0] = -C / B * Fpu + Hu;
        q1[1] = -C / B * Fpv + Hv;
        q2[0] = q1[0];
        q2[1] = q1[1];
      }
    }
  }
  return(success);
}
double solveLinf_C (
  int N,
  double p[153][2],
  double uv[102][2],
  double R[51][2][2],
  double xstar[2])
{
  int i;
  int j;
  int k;
  double ksq_min;
  double cf[4];
  double A[51];
  double b[51][2];
  double d0[51];
  double success;
  double q1[2];
  double q2[2];
  double A1;
  double A2;
  double B1[2];
  double B2[2];
  double C1;
  double C2;
  cf[0] = 0.0e0;
  cf[1] = 0.0e0;
  cf[2] = 0.0e0;
  cf[3] = 0.0e0;
  A[0] = 0;
  A[1] = 0;
  A[2] = 0;
  A[3] = 0;
  A[4] = 0;
  A[5] = 0;
  A[6] = 0;
  A[7] = 0;
  A[8] = 0;
  A[9] = 0;
  A[10] = 0;
  A[11] = 0;
  A[12] = 0;
  A[13] = 0;
  A[14] = 0;
  A[15] = 0;
  A[16] = 0;
  A[17] = 0;
  A[18] = 0;
  A[19] = 0;
  A[20] = 0;
  A[21] = 0;
  A[22] = 0;
  A[23] = 0;
  A[24] = 0;
  A[25] = 0;
  A[26] = 0;
  A[27] = 0;
  A[28] = 0;
  A[29] = 0;
  A[30] = 0;
  A[31] = 0;
  A[32] = 0;
  A[33] = 0;
  A[34] = 0;
  A[35] = 0;
  A[36] = 0;
  A[37] = 0;
  A[38] = 0;
  A[39] = 0;
  A[40] = 0;
  A[41] = 0;
  A[42] = 0;
  A[43] = 0;
  A[44] = 0;
  A[45] = 0;
  A[46] = 0;
  A[47] = 0;
  A[48] = 0;
  A[49] = 0;
  A[50] = 0;
  b[0][0] = 0;
  b[0][1] = 0;
  b[1][0] = 0;
  b[1][1] = 0;
  b[2][0] = 0;
  b[2][1] = 0;
  b[3][0] = 0;
  b[3][1] = 0;
  b[4][0] = 0;
  b[4][1] = 0;
  b[5][0] = 0;
  b[5][1] = 0;
  b[6][0] = 0;
  b[6][1] = 0;
  b[7][0] = 0;
  b[7][1] = 0;
  b[8][0] = 0;
  b[8][1] = 0;
  b[9][0] = 0;
  b[9][1] = 0;
  b[10][0] = 0;
  b[10][1] = 0;
  b[11][0] = 0;
  b[11][1] = 0;
  b[12][0] = 0;
  b[12][1] = 0;
  b[13][0] = 0;
  b[13][1] = 0;
  b[14][0] = 0;
  b[14][1] = 0;
  b[15][0] = 0;
  b[15][1] = 0;
  b[16][0] = 0;
  b[16][1] = 0;
  b[17][0] = 0;
  b[17][1] = 0;
  b[18][0] = 0;
  b[18][1] = 0;
  b[19][0] = 0;
  b[19][1] = 0;
  b[20][0] = 0;
  b[20][1] = 0;
  b[21][0] = 0;
  b[21][1] = 0;
  b[22][0] = 0;
  b[22][1] = 0;
  b[23][0] = 0;
  b[23][1] = 0;
  b[24][0] = 0;
  b[24][1] = 0;
  b[25][0] = 0;
  b[25][1] = 0;
  b[26][0] = 0;
  b[26][1] = 0;
  b[27][0] = 0;
  b[27][1] = 0;
  b[28][0] = 0;
  b[28][1] = 0;
  b[29][0] = 0;
  b[29][1] = 0;
  b[30][0] = 0;
  b[30][1] = 0;
  b[31][0] = 0;
  b[31][1] = 0;
  b[32][0] = 0;
  b[32][1] = 0;
  b[33][0] = 0;
  b[33][1] = 0;
  b[34][0] = 0;
  b[34][1] = 0;
  b[35][0] = 0;
  b[35][1] = 0;
  b[36][0] = 0;
  b[36][1] = 0;
  b[37][0] = 0;
  b[37][1] = 0;
  b[38][0] = 0;
  b[38][1] = 0;
  b[39][0] = 0;
  b[39][1] = 0;
  b[40][0] = 0;
  b[40][1] = 0;
  b[41][0] = 0;
  b[41][1] = 0;
  b[42][0] = 0;
  b[42][1] = 0;
  b[43][0] = 0;
  b[43][1] = 0;
  b[44][0] = 0;
  b[44][1] = 0;
  b[45][0] = 0;
  b[45][1] = 0;
  b[46][0] = 0;
  b[46][1] = 0;
  b[47][0] = 0;
  b[47][1] = 0;
  b[48][0] = 0;
  b[48][1] = 0;
  b[49][0] = 0;
  b[49][1] = 0;
  b[50][0] = 0;
  b[50][1] = 0;
  d0[0] = 0;
  d0[1] = 0;
  d0[2] = 0;
  d0[3] = 0;
  d0[4] = 0;
  d0[5] = 0;
  d0[6] = 0;
  d0[7] = 0;
  d0[8] = 0;
  d0[9] = 0;
  d0[10] = 0;
  d0[11] = 0;
  d0[12] = 0;
  d0[13] = 0;
  d0[14] = 0;
  d0[15] = 0;
  d0[16] = 0;
  d0[17] = 0;
  d0[18] = 0;
  d0[19] = 0;
  d0[20] = 0;
  d0[21] = 0;
  d0[22] = 0;
  d0[23] = 0;
  d0[24] = 0;
  d0[25] = 0;
  d0[26] = 0;
  d0[27] = 0;
  d0[28] = 0;
  d0[29] = 0;
  d0[30] = 0;
  d0[31] = 0;
  d0[32] = 0;
  d0[33] = 0;
  d0[34] = 0;
  d0[35] = 0;
  d0[36] = 0;
  d0[37] = 0;
  d0[38] = 0;
  d0[39] = 0;
  d0[40] = 0;
  d0[41] = 0;
  d0[42] = 0;
  d0[43] = 0;
  d0[44] = 0;
  d0[45] = 0;
  d0[46] = 0;
  d0[47] = 0;
  d0[48] = 0;
  d0[49] = 0;
  d0[50] = 0;
  B1[0] = 0.0e0;
  B1[1] = 0.0e0;
  B2[0] = 0.0e0;
  B2[1] = 0.0e0;
  q1[0] = undefined_;
  q1[1] = undefined_;
  q2[0] = undefined_;
  q2[1] = undefined_;
  for (i = 1; i <= N; i++)
  {
    computeAbd_C(p[3 * i - 2], p[3 * i - 1], p[3 * i - 3], uv[2 * i - 2], uv[2 * i - 1], R[i - 1], cf);
    A[i - 1] = cf[0];
    b[i - 1][0] = cf[1];
    b[i - 1][1] = cf[2];
    d0[i - 1] = cf[3];
  }
  ksq_min = infinity_;
  xstar[0] = 0.0e0;
  xstar[1] = 0.0e0;
  for (i = 1; i <= N; i++)
  {
    q1[0] = b[i - 1][0];
    q1[1] = b[i - 1][1];
    ksq_min = updateOpt_C(N, A, b, d0, q1, ksq_min, xstar, xstar);
    for (j = i + 1; j <= N; j++)
    {
      A1 = 0.0e0;
      B1[0] = -b[i - 1][1] + b[j - 1][1];
      B1[1] = b[i - 1][0] - b[j - 1][0];
      C1 = -b[i - 1][0] * b[j - 1][1] + b[i - 1][1] * b[j - 1][0];
      A2 = A[i - 1] - A[j - 1];
      B2[0] = -0.2e1 * b[i - 1][0] * A[i - 1] + 0.2e1 * b[j - 1][0] * A[j - 1];
      B2[1] = -0.2e1 * b[i - 1][1] * A[i - 1] + 0.2e1 * b[j - 1][1] * A[j - 1];
      C2 = A[i - 1] * (dot2(b[i - 1], b[i - 1]) - d0[i - 1]) - A[j - 1] * (dot2(b[j - 1], b[j - 1]) - d0[j - 1]);
      success = solveQQ_C(A1, B1, C1, A2, B2, C2, q1, q2);
      if (success)
      {
        ksq_min = updateOpt_C(N, A, b, d0, q1, ksq_min, xstar, xstar);
        ksq_min = updateOpt_C(N, A, b, d0, q2, ksq_min, xstar, xstar);
      }
      for (k = j + 1; k <= N; k++)
      {
        A1 = A[i - 1] - A[j - 1];
        B1[0] = -0.2e1 * b[i - 1][0] * A[i - 1] + 0.2e1 * b[j - 1][0] * A[j - 1];
        B1[1] = -0.2e1 * b[i - 1][1] * A[i - 1] + 0.2e1 * b[j - 1][1] * A[j - 1];
        C1 = A[i - 1] * (dot2(b[i - 1], b[i - 1]) - d0[i - 1]) - A[j - 1] * (dot2(b[j - 1], b[j - 1]) - d0[j - 1]);
        A2 = A[i - 1] - A[k - 1];
        B2[0] = -0.2e1 * b[i - 1][0] * A[i - 1] + 0.2e1 * b[k - 1][0] * A[k - 1];
        B2[1] = -0.2e1 * b[i - 1][1] * A[i - 1] + 0.2e1 * b[k - 1][1] * A[k - 1];
        C2 = A[i - 1] * (dot2(b[i - 1], b[i - 1]) - d0[i - 1]) - A[k - 1] * (dot2(b[k - 1], b[k - 1]) - d0[k - 1]);
        success = solveQQ_C(A1, B1, C1, A2, B2, C2, q1, q2);
        if (success)
        {
          ksq_min = updateOpt_C(N, A, b, d0, q1, ksq_min, xstar, xstar);
          ksq_min = updateOpt_C(N, A, b, d0, q2, ksq_min, xstar, xstar);
        }
      }
    }
  }
  return(ksq_min);
}
void test1() {
 double xstar[2];
double p[18][2];
double uvs[12][2];
double R[6][2][2];
p[0][0] = 0;
p[0][1] = 0.1e-11;
p[1][0] = 0.1e1;
p[1][1] = 0;
p[2][0] = 0.500000000000e0;
p[2][1] = 0.866025403785e0;
p[3][0] = 0;
p[3][1] = 0.1e-11;
p[4][0] = 0.500000000000e0;
p[4][1] = 0.866025403785e0;
p[5][0] = -0.500000000000e0;
p[5][1] = 0.866025403785e0;
p[6][0] = 0;
p[6][1] = 0.1e-11;
p[7][0] = -0.500000000000e0;
p[7][1] = 0.866025403785e0;
p[8][0] = -0.1e1;
p[8][1] = 0;
p[9][0] = 0;
p[9][1] = 0.1e-11;
p[10][0] = -0.1e1;
p[10][1] = 0;
p[11][0] = -0.500000000000e0;
p[11][1] = -0.866025403785e0;
p[12][0] = 0;
p[12][1] = 0.1e-11;
p[13][0] = -0.500000000000e0;
p[13][1] = -0.866025403785e0;
p[14][0] = 0.500000000000e0;
p[14][1] = -0.866025403785e0;
p[15][0] = 0;
p[15][1] = 0.1e-11;
p[16][0] = 0.500000000000e0;
p[16][1] = -0.866025403785e0;
p[17][0] = 0.1e1;
p[17][1] = 0;
uvs[0][0] = 0.1e1;
uvs[0][1] = 0;
uvs[1][0] = 0.500000000000e0;
uvs[1][1] = 0.866025403785e0;
uvs[2][0] = 0.500000000000e0;
uvs[2][1] = 0.866025403785e0;
uvs[3][0] = -0.500000000000e0;
uvs[3][1] = 0.866025403785e0;
uvs[4][0] = -0.500000000000e0;
uvs[4][1] = 0.866025403785e0;
uvs[5][0] = -0.1e1;
uvs[5][1] = 0;
uvs[6][0] = -0.1e1;
uvs[6][1] = 0;
uvs[7][0] = -0.500000000000e0;
uvs[7][1] = -0.866025403785e0;
uvs[8][0] = -0.500000000000e0;
uvs[8][1] = -0.866025403785e0;
uvs[9][0] = 0.500000000000e0;
uvs[9][1] = -0.866025403785e0;
uvs[10][0] = 0.500000000000e0;
uvs[10][1] = -0.866025403785e0;
uvs[11][0] = 0.1e1;
uvs[11][1] = 0;
R[0][0][0] = 0.999999999950e0;
R[0][0][1] = -0.999999999983e-5;
R[0][1][0] = 0.999999999983e-5;
R[0][1][1] = 0.999999999950e0;
R[1][0][0] = 0.999999999950e0;
R[1][0][1] = -0.999999999983e-5;
R[1][1][0] = 0.999999999983e-5;
R[1][1][1] = 0.999999999950e0;
R[2][0][0] = 0.999999999950e0;
R[2][0][1] = -0.999999999983e-5;
R[2][1][0] = 0.999999999983e-5;
R[2][1][1] = 0.999999999950e0;
R[3][0][0] = 0.999999999950e0;
R[3][0][1] = -0.999999999983e-5;
R[3][1][0] = 0.999999999983e-5;
R[3][1][1] = 0.999999999950e0;
R[4][0][0] = 0.999999999950e0;
R[4][0][1] = -0.999999999983e-5;
R[4][1][0] = 0.999999999983e-5;
R[4][1][1] = 0.999999999950e0;
R[5][0][0] = 0.999999999950e0;
R[5][0][1] = -0.999999999983e-5;
R[5][1][0] = 0.999999999983e-5;
R[5][1][1] = 0.999999999950e0;
float kstar = solveLinf_C(6,p,uvs,R,xstar);
printf("test 1, kstar = %g, xstar = (%g,%g)\n",kstar,xstar[0],xstar[1]);
}
void test2() {
 double xstar[2];
double p[18][2];
double uvs[12][2];
double R[6][2][2];
p[0][0] = 0;
p[0][1] = 0;
p[1][0] = 0.895503748750e0;
p[1][1] = 0.295520206661e0;
p[2][0] = 0.390491617293e0;
p[2][1] = 0.994607887518e0;
p[3][0] = 0;
p[3][1] = 0;
p[4][0] = 0.390491617293e0;
p[4][1] = 0.994607887518e0;
p[5][0] = -0.583960357602e0;
p[5][1] = 0.706768988034e0;
p[6][0] = 0;
p[6][1] = 0;
p[7][0] = -0.583960357602e0;
p[7][1] = 0.706768988034e0;
p[8][0] = -0.104475437354e1;
p[8][1] = -0.313251419061e0;
p[9][0] = 0;
p[9][1] = 0;
p[10][0] = -0.104475437354e1;
p[10][1] = -0.313251419061e0;
p[11][0] = -0.452148188445e0;
p[11][1] = -0.105311423384e1;
p[12][0] = 0;
p[12][1] = 0;
p[13][0] = -0.452148188445e0;
p[13][1] = -0.105311423384e1;
p[14][0] = 0.671554411242e0;
p[14][1] = -0.747544121959e0;
p[15][0] = 0;
p[15][1] = 0;
p[16][0] = 0.671554411242e0;
p[16][1] = -0.747544121959e0;
p[17][0] = 0.895503748750e0;
p[17][1] = 0.295520206661e0;
uvs[0][0] = 0.1e1;
uvs[0][1] = 0;
uvs[1][0] = 0.500000000000e0;
uvs[1][1] = 0.866025403785e0;
uvs[2][0] = 0.500000000000e0;
uvs[2][1] = 0.866025403785e0;
uvs[3][0] = -0.500000000000e0;
uvs[3][1] = 0.866025403785e0;
uvs[4][0] = -0.500000000000e0;
uvs[4][1] = 0.866025403785e0;
uvs[5][0] = -0.1e1;
uvs[5][1] = 0;
uvs[6][0] = -0.1e1;
uvs[6][1] = 0;
uvs[7][0] = -0.500000000000e0;
uvs[7][1] = -0.866025403785e0;
uvs[8][0] = -0.500000000000e0;
uvs[8][1] = -0.866025403785e0;
uvs[9][0] = 0.500000000000e0;
uvs[9][1] = -0.866025403785e0;
uvs[10][0] = 0.500000000000e0;
uvs[10][1] = -0.866025403785e0;
uvs[11][0] = 0.1e1;
uvs[11][1] = 0;
R[0][0][0] = 0.999999999950e0;
R[0][0][1] = -0.999999999983e-5;
R[0][1][0] = 0.999999999983e-5;
R[0][1][1] = 0.999999999950e0;
R[1][0][0] = 0.999999999950e0;
R[1][0][1] = -0.999999999983e-5;
R[1][1][0] = 0.999999999983e-5;
R[1][1][1] = 0.999999999950e0;
R[2][0][0] = 0.999999999950e0;
R[2][0][1] = -0.999999999983e-5;
R[2][1][0] = 0.999999999983e-5;
R[2][1][1] = 0.999999999950e0;
R[3][0][0] = 0.999999999950e0;
R[3][0][1] = -0.999999999983e-5;
R[3][1][0] = 0.999999999983e-5;
R[3][1][1] = 0.999999999950e0;
R[4][0][0] = 0.999999999950e0;
R[4][0][1] = -0.999999999983e-5;
R[4][1][0] = 0.999999999983e-5;
R[4][1][1] = 0.999999999950e0;
R[5][0][0] = 0.999999999950e0;
R[5][0][1] = -0.999999999983e-5;
R[5][1][0] = 0.999999999983e-5;
R[5][1][1] = 0.999999999950e0;
float kstar = solveLinf_C(6,p,uvs,R,xstar);
printf("test 2, kstar = %g, xstar = (%g,%g)\n",kstar,xstar[0],xstar[1]);
}
void test3() {
 double xstar[2];
double p[18][2];
double uvs[12][2];
double R[6][2][2];
p[0][0] = 0;
p[0][1] = 0;
p[1][0] = 0.895503748750e0;
p[1][1] = 0.295520206661e0;
p[2][0] = 0.390491617293e0;
p[2][1] = 0.994607887518e0;
p[3][0] = 0;
p[3][1] = 0;
p[4][0] = 0.390491617293e0;
p[4][1] = 0.994607887518e0;
p[5][0] = -0.583960357602e0;
p[5][1] = 0.706768988034e0;
p[6][0] = 0;
p[6][1] = 0;
p[7][0] = -0.583960357602e0;
p[7][1] = 0.706768988034e0;
p[8][0] = -0.104475437354e1;
p[8][1] = -0.313251419061e0;
p[9][0] = 0;
p[9][1] = 0;
p[10][0] = -0.104475437354e1;
p[10][1] = -0.313251419061e0;
p[11][0] = -0.452148188445e0;
p[11][1] = -0.105311423384e1;
p[12][0] = 0;
p[12][1] = 0;
p[13][0] = -0.452148188445e0;
p[13][1] = -0.105311423384e1;
p[14][0] = 0.671554411242e0;
p[14][1] = -0.747544121959e0;
p[15][0] = 0;
p[15][1] = 0;
p[16][0] = 0.671554411242e0;
p[16][1] = -0.747544121959e0;
p[17][0] = 0.895503748750e0;
p[17][1] = 0.295520206661e0;
uvs[0][0] = 0.1e1;
uvs[0][1] = 0.1e-1;
uvs[1][0] = 0.500000000000e0;
uvs[1][1] = 0.856025403785e0;
uvs[2][0] = 0.500000000000e0;
uvs[2][1] = 0.856025403785e0;
uvs[3][0] = -0.480000000000e0;
uvs[3][1] = 0.866025403785e0;
uvs[4][0] = -0.480000000000e0;
uvs[4][1] = 0.866025403785e0;
uvs[5][0] = -0.101e1;
uvs[5][1] = 0;
uvs[6][0] = -0.101e1;
uvs[6][1] = 0;
uvs[7][0] = -0.500000000000e0;
uvs[7][1] = -0.866025403785e0;
uvs[8][0] = -0.500000000000e0;
uvs[8][1] = -0.866025403785e0;
uvs[9][0] = 0.500000000000e0;
uvs[9][1] = -0.866025403785e0;
uvs[10][0] = 0.500000000000e0;
uvs[10][1] = -0.866025403785e0;
uvs[11][0] = 0.1e1;
uvs[11][1] = 0.1e-1;
R[0][0][0] = 0.999999999950e0;
R[0][0][1] = -0.999999999983e-5;
R[0][1][0] = 0.999999999983e-5;
R[0][1][1] = 0.999999999950e0;
R[1][0][0] = 0.999999999950e0;
R[1][0][1] = -0.999999999983e-5;
R[1][1][0] = 0.999999999983e-5;
R[1][1][1] = 0.999999999950e0;
R[2][0][0] = 0.999999999950e0;
R[2][0][1] = -0.999999999983e-5;
R[2][1][0] = 0.999999999983e-5;
R[2][1][1] = 0.999999999950e0;
R[3][0][0] = 0.999999999950e0;
R[3][0][1] = -0.999999999983e-5;
R[3][1][0] = 0.999999999983e-5;
R[3][1][1] = 0.999999999950e0;
R[4][0][0] = 0.999999999950e0;
R[4][0][1] = -0.999999999983e-5;
R[4][1][0] = 0.999999999983e-5;
R[4][1][1] = 0.999999999950e0;
R[5][0][0] = 0.999999999950e0;
R[5][0][1] = -0.999999999983e-5;
R[5][1][0] = 0.999999999983e-5;
R[5][1][1] = 0.999999999950e0;
float kstar = solveLinf_C(6,p,uvs,R,xstar);
printf("test 3, kstar = %g, xstar = (%g,%g)\n",kstar,xstar[0],xstar[1]);
}
void test4() {
 double xstar[2];
double p[18][2];
double uvs[12][2];
double R[6][2][2];
p[0][0] = 0;
p[0][1] = 0;
p[1][0] = 0.895503748750e0;
p[1][1] = 0.295520206661e0;
p[2][0] = 0.390491617293e0;
p[2][1] = 0.994607887518e0;
p[3][0] = 0;
p[3][1] = 0;
p[4][0] = 0.390491617293e0;
p[4][1] = 0.994607887518e0;
p[5][0] = -0.583960357602e0;
p[5][1] = 0.706768988034e0;
p[6][0] = 0;
p[6][1] = 0;
p[7][0] = -0.583960357602e0;
p[7][1] = 0.706768988034e0;
p[8][0] = -0.104475437354e1;
p[8][1] = -0.313251419061e0;
p[9][0] = 0;
p[9][1] = 0;
p[10][0] = -0.104475437354e1;
p[10][1] = -0.313251419061e0;
p[11][0] = -0.452148188445e0;
p[11][1] = -0.105311423384e1;
p[12][0] = 0;
p[12][1] = 0;
p[13][0] = -0.452148188445e0;
p[13][1] = -0.105311423384e1;
p[14][0] = 0.671554411242e0;
p[14][1] = -0.747544121959e0;
p[15][0] = 0;
p[15][1] = 0;
p[16][0] = 0.671554411242e0;
p[16][1] = -0.747544121959e0;
p[17][0] = 0.895503748750e0;
p[17][1] = 0.295520206661e0;
uvs[0][0] = 0.895503748750e0;
uvs[0][1] = 0.295520206661e0;
uvs[1][0] = 0.390491617293e0;
uvs[1][1] = 0.994607887518e0;
uvs[2][0] = 0.390491617293e0;
uvs[2][1] = 0.994607887518e0;
uvs[3][0] = -0.583960357602e0;
uvs[3][1] = 0.706768988034e0;
uvs[4][0] = -0.583960357602e0;
uvs[4][1] = 0.706768988034e0;
uvs[5][0] = -0.104475437354e1;
uvs[5][1] = -0.313251419061e0;
uvs[6][0] = -0.104475437354e1;
uvs[6][1] = -0.313251419061e0;
uvs[7][0] = -0.452148188445e0;
uvs[7][1] = -0.105311423384e1;
uvs[8][0] = -0.452148188445e0;
uvs[8][1] = -0.105311423384e1;
uvs[9][0] = 0.671554411242e0;
uvs[9][1] = -0.747544121959e0;
uvs[10][0] = 0.671554411242e0;
uvs[10][1] = -0.747544121959e0;
uvs[11][0] = 0.895503748750e0;
uvs[11][1] = 0.295520206661e0;
R[0][0][0] = 0.955336489126e0;
R[0][0][1] = -0.295520206661e0;
R[0][1][0] = 0.295520206661e0;
R[0][1][1] = 0.955336489126e0;
R[1][0][0] = 0.939372712847e0;
R[1][0][1] = -0.342897807455e0;
R[1][1][0] = 0.342897807455e0;
R[1][1][1] = 0.939372712847e0;
R[2][0][0] = 0.953846952568e0;
R[2][0][1] = -0.300293175209e0;
R[2][1][0] = 0.300293175209e0;
R[2][1][1] = 0.953846952568e0;
R[3][0][0] = 0.955225601879e0;
R[3][0][1] = -0.295878437058e0;
R[3][1][0] = 0.295878437058e0;
R[3][1][1] = 0.955225601879e0;
R[4][0][0] = 0.955329100822e0;
R[4][0][1] = -0.295544089981e0;
R[4][1][0] = 0.295544089981e0;
R[4][1][1] = 0.955329100822e0;
R[5][0][0] = 0.955336027374e0;
R[5][0][1] = -0.295521699374e0;
R[5][1][0] = 0.295521699374e0;
R[5][1][1] = 0.955336027374e0;
float kstar = solveLinf_C(6,p,uvs,R,xstar);
printf("test 4, kstar = %g, xstar = (%g,%g)\n",kstar,xstar[0],xstar[1]);
}
void test5() {
 double xstar[2];
double p[18][2];
double uvs[12][2];
double R[6][2][2];
p[0][0] = 0;
p[0][1] = 0;
p[1][0] = 0.927558408257e0;
p[1][1] = -0.169983987014e0;
p[2][0] = 0.819529056074e0;
p[2][1] = 0.685638884063e0;
p[3][0] = 0;
p[3][1] = 0;
p[4][0] = -0.785515760794e0;
p[4][1] = 0.724357330766e0;
p[5][0] = -0.870338885481e0;
p[5][1] = -0.288170654502e0;
p[6][0] = 0;
p[6][1] = 0;
p[7][0] = -0.913854137559e0;
p[7][1] = 0.73503176552e-1;
p[8][0] = -0.503174568219e0;
p[8][1] = -0.967705278725e0;
p[9][0] = 0;
p[9][1] = 0;
p[10][0] = 0.929688003133e0;
p[10][1] = -0.570366872641e0;
p[11][0] = 0.108656826922e1;
p[11][1] = 0.364495500876e0;
p[12][0] = 0;
p[12][1] = 0;
p[13][0] = -0.769434024713e0;
p[13][1] = 0.849387341232e0;
p[14][0] = -0.959205190344e0;
p[14][1] = -0.299554576583e0;
p[15][0] = 0;
p[15][1] = 0;
p[16][0] = 0.654787111498e0;
p[16][1] = 0.762273822291e0;
p[17][0] = -0.408437717371e0;
p[17][1] = 0.849963403682e0;
uvs[0][0] = 0.895503748750e0;
uvs[0][1] = 0.295520206661e0;
uvs[1][0] = 0.390491617293e0;
uvs[1][1] = 0.994607887518e0;
uvs[2][0] = 0.390491617293e0;
uvs[2][1] = 0.994607887518e0;
uvs[3][0] = -0.583960357602e0;
uvs[3][1] = 0.706768988034e0;
uvs[4][0] = -0.583960357602e0;
uvs[4][1] = 0.706768988034e0;
uvs[5][0] = -0.104475437354e1;
uvs[5][1] = -0.313251419061e0;
uvs[6][0] = -0.104475437354e1;
uvs[6][1] = -0.313251419061e0;
uvs[7][0] = -0.452148188445e0;
uvs[7][1] = -0.105311423384e1;
uvs[8][0] = -0.452148188445e0;
uvs[8][1] = -0.105311423384e1;
uvs[9][0] = 0.671554411242e0;
uvs[9][1] = -0.747544121959e0;
uvs[10][0] = 0.671554411242e0;
uvs[10][1] = -0.747544121959e0;
uvs[11][0] = 0.895503748750e0;
uvs[11][1] = 0.295520206661e0;
R[0][0][0] = 0.696706709347e0;
R[0][0][1] = -0.717356090899e0;
R[0][1][0] = 0.717356090899e0;
R[0][1][1] = 0.696706709347e0;
R[1][0][0] = 0.659983145884e0;
R[1][0][1] = 0.751280405140e0;
R[1][1][0] = -0.751280405140e0;
R[1][1][1] = 0.659983145884e0;
R[2][0][0] = 0.879968709836e0;
R[2][0][1] = 0.475031651272e0;
R[2][1][0] = -0.475031651272e0;
R[2][1][1] = 0.879968709836e0;
R[3][0][0] = -0.415805820760e0;
R[3][0][1] = 0.909453417952e0;
R[3][1][0] = -0.909453417952e0;
R[3][1][1] = -0.415805820760e0;
R[4][0][0] = -0.666294663701e0;
R[4][0][1] = -0.745688555043e0;
R[4][1][0] = 0.745688555043e0;
R[4][1][1] = -0.666294663701e0;
R[5][0][0] = 0.169968682664e0;
R[5][0][1] = 0.985449464413e0;
R[5][1][0] = -0.985449464413e0;
R[5][1][1] = 0.169968682664e0;
float kstar = solveLinf_C(6,p,uvs,R,xstar);
printf("test 5, kstar = %g, xstar = (%g,%g)\n",kstar,xstar[0],xstar[1]);
}
void testMain()
{ test1(); test2(); test3(); test4(); test5();}
